/*common.js
@author @fashion
@emil:15123976695@163.com
@time:2017-02-14
@param 公共方法
*/

/*
 openWin
 @name win名称
 @type 判断类型
 @win 地址
 @bodyParam 页面可携带参数
 * */
window.App = {};

//api方法配置

/*
 @param store/login
 App.url/store/login/token/zhongrui
 */
App = {
	url:'http://payment.verytong.com/index.php/Api/Store/',
	appToken : 'zhongrui',
	id:'A6932598296620',
	appKey:'CBA047A9-E04F-2343-0020-7EC06FD0D287',
	login:'login',//登录
	get_store_index:'get_store_index',//店铺首页
	get_payment_record:'get_payment_record',//付款列表
	get_bank_list:'get_bank_list',//银行提现列表
	submit_store_account:'store_account',//提交银行账户
	get_store_account:'get_store_account',//店铺提现账户列表
	delete_store_account:'delete_store_account',//删除银行卡
	store_withdrawal_info:'store_withdrawal_info',//店铺提现页面
	withdrawal:'withdrawal',//店铺提现
	get_withdrawal:'get_withdrawal',//提现记录列表,
	get_store_info:'get_store_info',
	get_store_qrcode:'get_store_qrcode',//付款二维码
	changePsw:'changepwd',
	forgetPsw:'forget',
	send_msg:'message',
	bind_registerId:'registration',//绑定设备唯一标识
	get_content:'get_article'
}
function openWin(name,type,url,bodyParam){
	if(!name) return;
	api.openWin({
		name:name,
		url:'widget://html/'+url+'.html',
		opaque:true,
		scrollToTop:true,
		vScrollBarEnabled:false,
		slidBackEnabled:false,//滑动返回IOS
		showProgress: true,
		reload:false,
		allowEdit:false,
		animation:{
			type:'push',
			subType:"from_right",
			curve:'ease_in_out',
			duration:300
		},
		slidBackType:'edge',
		pageParam:bodyParam
	});
}

/*检查网络*/
function detectionConnectionStatus(){

	var connectionType = api.connectionType;
	
	if(connectionType == 'wifi' || connectionType == '4g'){
		api.toast({
			msg:'当前网络状态良好',
			duration:2000,
			location:'bottom'
		});
	}
	api.addEventListener({
		name:'online'
	},function(ret,err){
	
		var connectionType = ret.connectionType;
		if(connectionType == 'wifi'){
			api.toast({
				msg:'当前网络状态良好',
				duration:2000,
				location:'bottom'
			});
		}
	});
}

/*
 用户是否登录
 * */
function getUserStatus(){
	//判断用户是否登录
	//$api.setStorage('userId','a001');//测试使用
	var status = false;
	var userId = $api.getStorage('deviceId');
//	alert(typeof userId);
	api.getPrefs({
	    key: 'user_status'
	}, function(ret, err) {
	    var status = ret.value;
//	    alert(status);
	});
	if(typeof userId == 'undefined'){
		var win_name = 'win_login';
		var url = 'login/'+win_name;
		api.toast({
			msg:'未检测到登录，请完成登录',
			duration: 1500,
			location:'bottom'
		});
		setTimeout(function(){
			openWin(win_name,'login',url);
		},1200);
		status = false;
		return status;
	}else{
		status = true;
		return status;
	}
}


/*进入应用*/
function enterApp(){
	if(!getUserStatus())return false;
	var win_name = 'main';
	openWin(win_name,'main',win_name,{});
}

/*更多*/
function jump_more(obj){
	if(typeof obj == 'undefined')return;
	var win_name = 'win_header';
	var paramJson = {
		type:'flow',
		title:'流水记录'
	}
	openWin(win_name,'flow',win_name,paramJson);
}

/*载入对应头部*/
function jump_to_page(obj,type){
	if(typeof obj == 'undefined')return;
	var win_name = 'win_header';
	var paramJson = {
		type:type,
		title:$api.text(obj)
	}
	openWin(win_name,paramJson.type,win_name,paramJson);
}

/*提现*/
function cash_money(obj,index){
	if($api.hasCls(obj,'app-disabled')){
		api.toast({
			msg:'申请处理中，请勿频繁操作',
			duration:2000,
			location:'bottom'
		});
		return;
	}
	api.execScript({
		name:'main',
		script:'switchTab(\''+obj+'\',\''+index+'\')'
	})
}

/*版本更新*/
function update_version(){
	var mam = api.require('mam');
	mam.checkUpdate(
	    function(ret,err) {
    	//coding...
	    	if(ret){
	    		if(ret.result.update){
	    			if(api.systemType == 'ios'){
	    				api.installApp({
						    appUri: ret.result.source
						});
	    			}else{
	    				api.download({
			                url:ret.result.source,
			                encode:true,
			                report:true,
		                },function(ret,err){
		                	//coding...
		                	alert(ret.state);
		                	if(ret.state == 1){
		                		//alert(JSON.stringify(ret));
		                		api.installApp({
								    appUri: ret.savePath
								});
		                	}
		                });
		    		}
	    		}else{
	    			api.toast({
						msg:'已是最新版本，无需更新',
						duration:1500
					});
	    		}
	    	}else{
	    		alert(JSON.stringify(err));
	    	}
    	});
	    return;
		api.toast({
			msg:'已是最新版本，无需更新',
			duration:1500
		});
	}


/*渲染模板数据*/
function rendererData(cont,tmpl,resData){
	var box = $api.byId(cont);
	var tmpl = $api.byId(tmpl).text;
	var tplFn = doT.template(tmpl);
	
	$api.append(box,tplFn(resData));
	api.parseTapmode();
	return;
};

/*
 返回操作
 * */

function historyBack(){
	api.closeWin();
}

function cancelCur(obj,name){
	if(!obj) return;
	api.closeWin({
		name:name
	});
}

function getHeaderHeight(selector){
	if(selector && selector != ''){
		var ele = $api.dom(selector);
		return $api.offset(ele).h;
	}else{
		console.warn('selector不能为空');
	}
}


/*
 手机号验证
 * */

function isPhoneNumber(tel){
	return /^1[1|3|5|8|][0-9]{9}$/.test(tel);
}

/*处理银行卡号*/
function subStrCard(str){
	if(typeof str != 'string')return;
	return str.replace(str.substr(0,str.length-4),'****');
}

//判断商户是否添加默认银行卡
function isCusAddCard(){
	return isadd;
}

/*
 写入本地
 * */


 //设置应用点击两次返回，可退出应用
 function tapTimeoutExitApp(){
	    var time = 0;
	    api.addEventListener({
	    	name:'keyback'
	    },function(ret,err){
	    	var curTime = new Date().getTime()/1000;
	    	if(curTime - time > 2){
	    		time = curTime;
		    		api.toast({
		            msg:'再按一次返回键退出应用',
		            duration:2000,
		            location:'bottom'
            	});
            	return;
	    	}else{
	    		api.closeWidget({
	                id: 'A6932598296620',
	                retData: {
				        name: '退出应用'
				    },
				    silent:true,//静默退出应用
				    animation: {
				        type: 'flip',
				        subType: 'from_bottom',
				        duration: 500
				    }
                });
	    	}
            
	    });
	 }  	 
	 
/*
 选择整点判断 是否加零
 * */	 
 
 function isDouble(str){
 	return str = str < 10 ? '0'+str : str;
 }
 
 //通过时间戳获取具体时间
 function getTimeFromTimestamp(stamp){
 	var myDate = new Date();
 	myDate.setTime(stamp);
	var hours = isDouble(myDate.getHours());
	var minutes = isDouble(myDate.getMinutes());
	return hours + ':' + minutes;
 }
 
 //toast弹窗
 function popToast(msg,location){
 	api.toast({
 		msg:msg,
 		duration:1500,
 		location:location
 	});
 }
 

//提取图片
function getPicture(source,ecode,pname,quality,issave,targetWidth,targetHeight,callback){
	api.getPicture({
		sourceType:source,
	    encodingType: ecode,
	    mediaValue: pname,
	    destinationType: 'url',
	    allowEdit: true,
	    quality: quality,
	    targetWidth: targetWidth || 80,
	    targetHeight: targetHeight || 80,
	    saveToPhotoAlbum: issave
    },function(ret,err){
    	if(ret){
    		var path = ret.data;
    		callback(path);
    	}else{
    		api.toast({
	            msg:'上传失败',
	            duration:2000,
	            location:'bottom'
            });
    	}
    });
}

//本地资源库选择
function UIMediaScanner(type,max,callback){
	var UIMediaScanner = api.require('UIMediaScanner');
	UIMediaScanner.open({
		type:type,
		column:4,
		classify:true,
		max:max,
		sort:{
			key:'time',
			order:'desc'
		},
		texts:{
			stateText:'已选择1项',
			cancelText:'取消',
			finishText:'完成'
		},
		 styles: {
	        bg: '#fff',
	        mark: {
	            icon:'',
	            position:'bottom_left',
	            size:20
	        },
	        nav: {
	            bg: '#eee',
	            stateColor: '#000',
	            stateSize: 18,
	            cancelBg: 'rgba(0,0,0,0)',
	            cancelColor: '#000',
	            cancelSize: 18,
	            finishBg: 'rgba(0,0,0,0)',
	            finishColor: '#000',
	            finishSize: 18
	     },
	     scrollToBottom: {
	        intervalTime: 3,
	        anim: true
	    },
		    exchange: true,
		    rotation: true
	    },
	},function(ret,err){
		 if (ret) {
	       callback(ret);
	    }
	});
}


//获取app信息
function getAppInfo(callback){
	ajaxRequest(App.API.about_app+'?token='+App.token,'get','',function(ret,err){
		if(ret && ret.status == 200){
			//alert(JSON.stringify(ret));
			callback(ret);
		}else{
			api.toast({
				msg:'信息加载失败',
				duration:2000,
				location:'bottom'
			});
		}
	});
}

/*
 数据写入本地缓存策略
 @param writeFile 写入本地缓存
 @param readFile 读取本地缓存数据
 @param 本地缓存数据是否有更新内容
 * 
 * */

function doCache(folder,id,url,callback){
	alert(folder+'id'+id);
 	readFile(folder+'/'+id+'.json',function(ret,err){
 		if(ret.status){
 			var retData = JSON.stringify(ret.data);
 			callback(JSON.parse(retData));
 			alert('读取到缓存数据');
 			//防止内容有更新
 			return;
 			ajaxRequest(url,'GET','',function(ret,err){
 				if(ret){
 					//判断缓存数据与请求返回数据是否相等
 					alert('比较缓存数据');
 					if(retData != JSON.stringify(ret)){
// 						alert(JSON.stringify(ret));
 						callback(ret);
 						alert('1525');
 						writeFile(folder,id,ret);
 					}else{
 						api.toast({
 							msg:'数据没有最新的'
 						});
 					}
 				}else{
 					api.toast({
 						msg:'数据获取失败，请重试',
 						duration:2000,
 						location:'bottom'
 					});
 				}
 			});
 		}
 		else{
 			alert('没有读取到缓存数据');
 			ajaxRequest(url,'GET','',function(ret,err){
 				if(ret){
 					callback(ret);
 					writeFile(folder,id,ret);
 				}else{
 					api.toast({
 						msg:'数据获取失败，请重试',
 						duration:2000,
 						location:'bottom'
 					});
 				}
 			});
 		}
 	});
}

function writeFile(path,id,resData){
	alert('写入最新数据');
	api.writeFile({
	    path:api.cacheDir+'/cache/'+path+'/'+id+'.json',//save path
	    data:JSON.stringify(resData),//transform data
	    append:true
    },function(ret,err){
    	//coding...
    });
}

function readFile(path,callback){
	api.showProgress({
		title:'正在加载缓存数据'
	});
	alert(api.cacheDir+'/cache/'+path);
	api.readFile({
	    path:api.cacheDir+'/cache/'+path
    },function(ret,err){
    	//coding...
    	callback(ret,err);
    	api.hideProgress();
    });
}
/*搜索时 阻止冒泡*/
function collapseSearch(obj){
	$(obj).find('.search-bar').addClass('collapse');
}
	
function stopPropagation(e){
	e.stopPropagation();
}

/*
	shai加密
*/

function SHA1(msg) {

    function rotate_left(n, s) {
        var t4 = ( n << s ) | (n >>> (32 - s));
        return t4;
    };

    function lsb_hex(val) {
        var str = "";
        var i;
        var vh;
        var vl;

        for (i = 0; i <= 6; i += 2) {
            vh = (val >>> (i * 4 + 4)) & 0x0f;
            vl = (val >>> (i * 4)) & 0x0f;
            str += vh.toString(16) + vl.toString(16);
        }
        return str;
    };

    function cvt_hex(val) {
        var str = "";
        var i;
        var v;

        for (i = 7; i >= 0; i--) {
            v = (val >>> (i * 4)) & 0x0f;
            str += v.toString(16);
        }
        return str;
    };


    function Utf8Encode(string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    };

    var blockstart;
    var i, j;
    var W = new Array(80);
    var H0 = 0x67452301;
    var H1 = 0xEFCDAB89;
    var H2 = 0x98BADCFE;
    var H3 = 0x10325476;
    var H4 = 0xC3D2E1F0;
    var A, B, C, D, E;
    var temp;

    msg = Utf8Encode(msg);

    var msg_len = msg.length;

    var word_array = new Array();
    for (i = 0; i < msg_len - 3; i += 4) {
        j = msg.charCodeAt(i) << 24 | msg.charCodeAt(i + 1) << 16 |
            msg.charCodeAt(i + 2) << 8 | msg.charCodeAt(i + 3);
        word_array.push(j);
    }

    switch (msg_len % 4) {
        case 0:
            i = 0x080000000;
            break;
        case 1:
            i = msg.charCodeAt(msg_len - 1) << 24 | 0x0800000;
            break;

        case 2:
            i = msg.charCodeAt(msg_len - 2) << 24 | msg.charCodeAt(msg_len - 1) << 16 | 0x08000;
            break;

        case 3:
            i = msg.charCodeAt(msg_len - 3) << 24 | msg.charCodeAt(msg_len - 2) << 16 | msg.charCodeAt(msg_len - 1) << 8 | 0x80;
            break;
    }

    word_array.push(i);

    while ((word_array.length % 16) != 14) word_array.push(0);

    word_array.push(msg_len >>> 29);
    word_array.push((msg_len << 3) & 0x0ffffffff);


    for (blockstart = 0; blockstart < word_array.length; blockstart += 16) {

        for (i = 0; i < 16; i++) W[i] = word_array[blockstart + i];
        for (i = 16; i <= 79; i++) W[i] = rotate_left(W[i - 3] ^ W[i - 8] ^ W[i - 14] ^ W[i - 16], 1);

        A = H0;
        B = H1;
        C = H2;
        D = H3;
        E = H4;

        for (i = 0; i <= 19; i++) {
            temp = (rotate_left(A, 5) + ((B & C) | (~B & D)) + E + W[i] + 0x5A827999) & 0x0ffffffff;
            E = D;
            D = C;
            C = rotate_left(B, 30);
            B = A;
            A = temp;
        }

        for (i = 20; i <= 39; i++) {
            temp = (rotate_left(A, 5) + (B ^ C ^ D) + E + W[i] + 0x6ED9EBA1) & 0x0ffffffff;
            E = D;
            D = C;
            C = rotate_left(B, 30);
            B = A;
            A = temp;
        }

        for (i = 40; i <= 59; i++) {
            temp = (rotate_left(A, 5) + ((B & C) | (B & D) | (C & D)) + E + W[i] + 0x8F1BBCDC) & 0x0ffffffff;
            E = D;
            D = C;
            C = rotate_left(B, 30);
            B = A;
            A = temp;
        }

        for (i = 60; i <= 79; i++) {
            temp = (rotate_left(A, 5) + (B ^ C ^ D) + E + W[i] + 0xCA62C1D6) & 0x0ffffffff;
            E = D;
            D = C;
            C = rotate_left(B, 30);
            B = A;
            A = temp;
        }

        H0 = (H0 + A) & 0x0ffffffff;
        H1 = (H1 + B) & 0x0ffffffff;
        H2 = (H2 + C) & 0x0ffffffff;
        H3 = (H3 + D) & 0x0ffffffff;
        H4 = (H4 + E) & 0x0ffffffff;

    }

    var temp = cvt_hex(H0) + cvt_hex(H1) + cvt_hex(H2) + cvt_hex(H3) + cvt_hex(H4);

    return temp.toLowerCase();

}

//发送后台数据请求方法
function ajaxRequest(url, method, bodyParam, callBack) {
    var common_url = url;
    var appId = App.id;
    var key = App.appKey;
    var now = Date.now();
    var appKey = SHA1(appId + "UZ" + key + "UZ" + now) + "." + now;
    api.ajax({
        url: common_url + url,
        method: method,
        cache: false,
        timeout: 20,
        headers: {
            "Content-Type": "'application/json;charset=utf-8",
            "X-APICloud-AppId": appId,
            "X-APICloud-AppKey": appKey
        },
        data: {
            body:bodyParam
        }
    }, function (ret, err) {
    	//alert(JSON.stringify(ret));
        callBack(ret, err);
    });
}