//login.js
//Vue.component('my-component', {
//template: '<p class="foo bar">Hi</p>'
//})
var data = {msg:'hello',name:'fashion'}
var myComponent = Vue.extend({
	template:'<div class="div" :text="msg" :title="name">组件标题{{msg}}</div>',
	props:['title'],
	data:function(){
		return data
	}
})
Vue.component('my-component',myComponent)
var vue = new Vue({
	el:'#login-info',
	data:{
		uname:'',
		psw:'',
		psw2:'',
		verify_code:'',
		btn_ok:true
	},
	watch:{
		'uname':function(newname,oldname){
			console.log('wating');
			console.log(newname+'--'+oldname+this.calculate);
		}
	},
	computed:{
		calculate:function(){
			return 'Hello'
		}
	}
});



//vue.$watch('uname',function(newname,oldname){
//	console.log('wating');
//	console.log(newname+'--'+oldname+this.calculate);
//})

function app_login(obj){
	if(!$api.hasCls(obj, 'app-btn-ok')){
		api.toast({
			msg:'请填写相应选项',
			duration:2000,
			location:'top'
		});
		return;
	}
//	if(!isPhoneNumber(vue.uname)){
//		api.toast({
//			msg:'填写的手机号码有误',
//			duration:2000,
//			location:'bottom'
//		});
//		return;
//	}
	
	//登录操作
	//alert(App.url+App.login);
	api.showProgress({
		title:'登录中'
	});
	api.ajax({
	    url:App.url+App.login,
	    method:'post',
	    cache:false,
	    timeout:20,
	    data:{
	    	values:{
	    		token:'zhongrui',
	    		username:vue.uname,
	    		password:vue.psw
	    	}
	    }
    },function(ret,err){
    	//coding...
    	if(ret && ret.status == 200){
    		//设置用户登录状态
    		//alert(JSON.stringify(ret));
			api.setPrefs({
			    key:'user_status',
			    value:'ok'
		    });
		    if(ret.logo == null){
		    	$api.setStorage('icon','../image/accout_info@2x.png');
		    }
		    $api.setStorage('icon',ret.logo);
		    $api.setStorage('nickname',ret.name);
		    $api.setStorage('store_id',ret.store_id)
		    $api.setStorage('deviceId',api.deviceId);
		    
		    api.sendEvent({
		    	name:'login',
		    	extra:{
		    		deviceId:api.deviceId
		    	}
		    });
		    
		    api.toast({
	    		msg:ret.msg,
	    		duration:1500,
	    		location:'bottom'
	    	});
	    	
	    	//发送商家推送唯一标识
	    	//alert($api.getStorage('registration_is_ok'));
	    	//alert($api.getStorage('registration_id'));
	    	//postDeviceId($api.getStorage('store_id'),$api.getStorage('registration_id'));
	    	if(!$api.getStorage('registration_is_ok')){
	    		api.ajax({
		            url:App.url+App.bind_registerId,
		            method:'post',
		            cache:false,
		            timeout:20,
		            data:{
		            	values:{
		            		store_id:$api.getStorage('store_id'),
		            		token:App.appToken,
		            		registration_id:$api.getStorage('registration_id')
		            	}
		            }
	            },function(ret,err){
	            	//coding...
	            	//alert(JSON.stringify(ret));
	            	if(ret.status == 200){
	            		$api.setStorage('registration_is_ok',true);
	            	}else{
	            		//alert(JSON.stringify(ret));
	            	}
	            });
	    	}
	    	
		    setTimeout(function(){
		    	var win_name = 'main';
				openWin(win_name,'main',win_name,{});
		    },1700);
			
	    }else{
	    	api.toast({
	    		msg:ret.msg,
	    		duration:1500,
	    		location:'bottom'
	    	});
	    }
	    
	    api.hideProgress();
    });
}

//忘记密码

function forgetPsw(){
	var win_name = 'win_update_psw_header';
	var paramJson = {
		type:'update_psw',
		title:'忘记密码'
	}
	openWin(win_name,'update_psw',win_name,paramJson);
}

//修改密码

function changePsw(obj){
	var store_id = $api.getStorage('store_id');
	if(!$api.hasCls(obj, 'app-btn-ok')){
		api.toast({
			msg:'请填写相应选项',
			duration:2000,
			location:'top'
		});
		return;
	}
	
	if(vue.psw !== vue.psw2){
		api.toast({
			msg:'前后密码输入不一致',
			duration:2000,
			location:'bottom'
		});
		return;
	}
	
	api.ajax({
		url:App.url+App.changePsw,
		method:'post',
		timeout:20,
		cache:false,
		data:{
			values:{
				token:App.appToken,
				store_id:store_id,
				password:vue.psw,
				newpassword:vue.psw2
				
			}
		}
	},function(ret,err){
		if(ret && ret.status == 200){
			api.toast({
				msg:'密码修改成功',
				duration:2000,
				location:'bottom'
			});
			$api.rmStorage('store_id');
			$api.rmStorage('icon');
			$api.rmStorage('nickname');
			
			var win_name = 'win_login';
			var url = 'login/'+win_name;
			
			api.sendEvent({
				name:'logout'
			});
			
			setTimeout(function(){
				openWin(win_name,'login',url);
			},1500);
			
			
		}else{
			api.toast({
				msg:'修改失败，请重试',
				duration:2000,
				location:'bottom'
			});
		}
	});
}

//发送验证码
function send_code(obj){
	if($api.hasCls(obj, 'app-disabled'))return;
	if(vue.uname == ''){
		api.toast({
			msg:'填写接收短信手机号',
			duration:1500,
			location:'bottom'
		});
		return;
	}
	sendsmsVerify(vue.uname,obj);
}

//验证码倒计时
var sconds = 60;
function timeout_code(obj){
	if(sconds == 0){
		vue.btn_ok = true;
		$api.text(obj,'发送验证码');
		sconds = 60;
		return;
	}else{
		vue.btn_ok = false;
		$api.text(obj,sconds+'s后重试');
	}
	
	setTimeout(function(){
		sconds--;
		timeout_code(obj);
	},1000);
}

//发送验证码
function sendsmsVerify(tel,obj){
	//alert(333);
	smsVerify = api.require('smsVerify');
	smsVerify.register(function(ret, err){
	    if(ret.status){
	        //api.alert({msg: '注册成功'});
	    }else{
	        //api.alert({msg: err.code+' 注册失败'});
	    }
	});
	smsVerify.sms({
	    phone:tel,
	    country:"86"
	},function(ret, err){
	    if(ret.status){
            api.toast({
            	msg: '验证码已发送,请查收',
            	duration:1500,
            	location:'bottom'
            });
            timeout_code(obj);
	    }else{
	    	//alert(JSON.stringify(ret));
	        api.toast({
	        	msg:'发送失败,请重试',
	        	duration:1500,
	        	location:'bottom'
	        });    
	    }
	});
}

//校验验证码
function verify_code(){
	smsVerify = api.require('smsVerify');
	smsVerify.verify({
		phone:vue.uname,
		country:'86',
		code:vue.verify_code
	},function(ret,err){
		if(ret.status){
			api.ajax({
				url:App.url+App.forgetPsw,
				method:'post',
				timeout:20,
				cache:false,
				data:{
					values:{
						token:App.appToken,
						mobile:vue.uname,
						password:vue.psw,
						newpassword:vue.psw2
					}
				}
			},function(ret,err){
				api.toast({
					msg:'密码修改成功',
					duration:2000,
					location:'bottom'
				});
				setTimeout(function(){
					historyBack()
				},1500);
			});
		}else{
			api.toast({
				msg:err.msg,
				duration:1500,
				location:'bottom'
			});
		}
	});
}

//修改密码
function update_psw(obj){
	if(!$api.hasCls(obj, 'app-btn-ok')){
		api.toast({
			msg:'请填写相应选项',
			duration:2000,
			location:'top'
		});
		return;
	}
	if(!isPhoneNumber(vue.uname)){
		api.toast({
			msg:'填写的手机号码有误',
			duration:2000,
			location:'bottom'
		});
		return;
	}
	if(vue.psw !== vue.psw2){
		api.toast({
			msg:'前后密码输入不一致',
			duration:2000,
			location:'bottom'
		});
		return;
	}
	
	verify_code();
}


//发送推送标识
function postDeviceId(store_id,regisId){
	alert(App.url+App.bind_registerId+'/token/'+App.appToken+'/store_id/'+store_id+'/registration_id/'+regisId);
	ajaxRequest(App.url+App.bind_registerId+'/token/'+App.appToken+'/store_id/'+store_id+'/registration_id/'+regisId,'get',{},function(ret,err){
		alert(JSON.stringify(ret));
    	if(ret.status == 200){
    		$api.setStorage('registration_is_ok',true);
    	}else{
    		alert(JSON.stringify(ret));
    	}
	});
}
